
#include "config.h"
#include "reduce_server.h"

tally_t init()
{
  tally_t t = { 1, 0, 0, 0, 0 };
  return t;
}

static tally_t do_combine(tally_t tally, int x, int y)
{
  if (tally.zero) {
    tally.zero = 0;
    tally.x_hi = tally.x_lo = x;
    tally.y_hi = tally.y_lo = y;
    return tally;
  } else {
    if (x < tally.x_lo)
      tally.x_lo = x;
    if (x > tally.x_hi)
      tally.x_hi = x;
    if (y < tally.y_lo)
      tally.y_lo = y;
    if (y > tally.y_hi)
      tally.y_hi = y;
  }

  return tally;
}

tally_t accum(tally_t tally, int i, data_t *myArray)
{
  return do_combine(tally, myArray[i].x, myArray[i].y);
}

tally_t combine(tally_t tally1, tally_t tally2)
{
  if (tally2.zero)
    return tally1;
  else
    return do_combine(do_combine(tally1, tally2.x_hi, tally2.y_hi),
                      tally2.x_lo, tally2.y_lo);
}

result_t reduceGen(tally_t tally)
{
  if (tally.zero)
    return 0;
  else
    return ((tally.x_hi - tally.x_lo)
            * (tally.y_hi - tally.y_lo));
}
