
/* A fullempty variable is "named" by a non-negative index.
   The array of such variables is created on demand, and all
   fullempty variables are initially empty. */

/* Loop, handling messages from an array of connections, where
   each message can put/get a fullempty variable's value.
   When a value is available for start_check though end_check-1,
   then return. */
void fullempty_loop(int t, struct connection_t **c, int start_check, int end_check);

/* Get the value of a fullempty variable (after loop
   that ensures it's filled): */
void fullempty_get(int id, int len, void *dest);

/* Returns the number of bytes available for the value of a fullempty
   variable, returning -1 if no value is available. */
int fullempty_bytes_available(int id);
