#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "bmsg.h"
#include "fullempty_server.h"

#include "config.h"
#include "scan_server.h"

/* Map the nodeval' variable to emptyfree id t...2*t-1: */
#define NODEVAL(i) ((i) + real_t)

/* Map the pval' variable to emptyfree id 2*t...3*t-1: */
#define PVAL(i) ((i) + (2 * real_t))

static tally_t localTally(int size, data_t *myArray);
static tally_t propagateParentTally(int t, int real_t, struct connection_t *c, int index);
static void localScanGen(tally_t tally, int size, data_t *myArray, result_t *myResult);

int main(int argc, char **argv)
{
  struct connection_t *c;
  int t, real_t, nums[3], n, index;
  char msg[4];
  data_t *myArray;
  result_t *myResult;

  do {
    c = wait_for_connection(argv[1]);

    recv_byte_message(c, sizeof(nums), nums);
    index = nums[0];
    t = nums[1];
    n = nums[2];

    real_t = t; /* <<< PART 3 CHANGE <<< */
    for (t = 1; t < real_t; t *= 2) { }

    printf("Connected as %d of %d; %d elements\n", index, t, n);

    myArray = (data_t *)malloc(n * sizeof(data_t));
    myResult = (result_t *)malloc(n * sizeof(result_t));

    prepate_temps(n); /* <<< PART 2 CHANGE <<<< */
    
    recv_byte_message(c, n * sizeof(data_t), myArray);

    {
      tally_t tally, ptally, child_tally;
      int stride;
      
      tally = localTally(n, myArray);
      
      for (stride = 1; stride < t; stride *= 2) {
        if (index % (2 * stride) == 0) {
          if (index + stride < real_t) { /* <<< PART 3 CHANGE <<< */
            fullempty_put(c, PVAL(index + stride), sizeof(tally_t), &tally);
            fullempty_get(c, NODEVAL(index + stride), sizeof(tally_t), &child_tally);
            tally = combine(tally, child_tally);
          }
        } else {
          fullempty_put(c, NODEVAL(index), sizeof(tally_t), &tally);
          break;
        }
      }

      ptally = propagateParentTally(t, real_t, c, index); /* <<< PART 3 CHANGE <<< */

      localScanGen(ptally, n, myArray, myResult);

      fullempty_put(c, index, n * sizeof(result_t), myResult);
    }

    /* wait for done message: */
    recv_byte_message(c, 4, msg);
    if (memcmp(msg, "done", 4)) {
      printf("didn't receive expected \"done\" message\n");
      abort();
    }

    close_connection(c);

    free(myArray);
    free(myResult);

    printf("Done\n");
  } while (0); /* <- change 0 to 1 to loop */

  return 0;
}

tally_t localTally(int size, data_t *myArray)
{
  int i;
  tally_t tally = init();
 
  for (i = 0; i < size; i++)
   tally = accum(tally, i, myArray);

  return tally;
}

tally_t propagateParentTally(int t, int real_t, struct connection_t *c, int index)
{
  tally_t ptally;
  int stride;
  
  if (index == 0)
    ptally = init();
  else {
    /* Parent supplies left total then parent */
    tally_t ptally2;
    fullempty_get(c, PVAL(index), sizeof(tally_t), &ptally);
    fullempty_get(c, PVAL(index), sizeof(tally_t), &ptally2);
    ptally = combine(ptally, ptally2);
  }
  
  /* Propagate total from parent to right children */
  for (stride = 1; stride < t; stride *= 2) {
    if (index % (2 * stride) == 0) {
      if (index + stride < real_t) /* <<< PART 3 CHANGE <<< */
        fullempty_put(c, PVAL(index + stride), sizeof(tally_t), &ptally);
    } else
      break;
  }

  return ptally;
}

void localScanGen(tally_t ptally, int size,
                  data_t *myArray, result_t *myResult)
{
  int i;
  for (i = 0; i < size; i++)
    ptally = scanGen(ptally, i, myArray, myResult);
}
